升级openssh编译报错“configure: error: *** working libcrypto not found, check config.log”的解决办法

问题描述

linux上,欲将OpenSSH_6.4p1编译升级到OpenSSH_8.0p1时,执行了./configure --prefix=/usr --sysconfdir=/etc/ssh --with-zlib --without-openssl-header-check --with-ssl-dir=/usr/local/ssl --with-privsep-path=/var/lib/sshd编译命令后报错,报错信息如下:

configure: error: *** working libcrypto not found, check config.log ***

或:

configure: error: *** OpenSSL headers missing - please install first or check config.log ***

报错分析和解决办法

报错原因

出现上述两种报错,是因为缺少openssl-devel包或者libcrypto相关库的位置不正确。

解决办法

  • 第一种解决办法 -- 最推荐的解决办法(最简单有效)
    yum安装openssl-devel包即可:
yum install -y openssl-devel
  • 第二种解决办法
    尝试将编译参数--with-ssl-dir=/usr/local/ssl修改为--with-ssl-dir=/usr/local后再尝试编译;完整编译命令行如下:
./configure --prefix=/usr --sysconfdir=/etc/ssh --with-zlib --without-openssl-header-check --with-ssl-dir=/usr/local --with-privsep-path=/var/lib/sshd
  • 第三种解决办法 -- yum update来升级OpenSSH(第一种方法无效的情况下推荐此方法)
    先执行yum update opensshOpenSSH_6.4p1升级到高版本(版本比6.4高,肯定不会高于8.0)后,再编译升级到OpenSSH_8.0p1
yum update openssh
  • 第四种解决办法
    如果在生产环境中不支持直接yum安装openssl-devel或者升级OpenSSH的情况下,可先将当前OpenSSH版本编译升级到OpenSSH_7.4p1后再编译升级到OpenSSH_8.0p1

附:升级OpenSSH的教程:https://www.cnblogs.com/wholj/p/10897274.html

posted @ 2019-05-29 16:06  长翅膀的蜗牛  阅读(28266)  评论(1编辑  收藏  举报